<template>
  <div>
    <v-container class="d-flex justify-center mb-10 px-10">
      <v-sheet max-width="1300px">
        <!-- Headline -->
        <v-row>
          <v-col cols="12">
            <v-card
              class="mx-auto"
              outlined
              color="#385F73"
            >
              <v-container class="d-flex justify-space-between px-5 white--text">
                <div>
                  <v-card-title class="headline">
                    Accelerate research discovery to shape a better future
                  </v-card-title>

                  <v-card-subtitle class="white--text text--darken-5">
                    2 billion items available here through a library
                  </v-card-subtitle>

                  <v-container>
                    <form
                      class="d-flex align-center mb-3"
                      @submit.prevent="trigger"
                    >
                      <v-text-field
                        v-model="searchParams.q[0]"
                        label="Search theses here..."
                        placeholder="Search theses here..."
                        outlined
                        hide-details
                        dark
                        class="mr-2"
                        autocomplete="off"
                      />

                      <div class="text-center">
                        <v-btn
                          type="submit"
                          large
                        >
                          Search
                        </v-btn>
                      </div>
                    </form>
                  </v-container>

                  <v-card-subtitle class="white--text text--darken-5">
                    LNU Archive connects you to the collections and services of more than 10,000 reading materials
                  </v-card-subtitle>
                </div>

                <v-img
                  max-width="300"
                  class="ma-5"
                  contain
                  :src="require('@/assets/images/svg/book_lover_white.svg')"
                />
              </v-container>
            </v-card>
          </v-col>
        </v-row>

        <!-- Most most -->
        <v-row>
          <!-- Most Popular Tags -->
          <v-col
            v-if="0"
            cols="12"
            sm="12"
            md="6"
          >
            <v-card
              class="mx-auto"
              outlined
            >
              <v-container>
                <div class="d-flex">
                  <v-img
                    class="ml-3"
                    max-width="50"
                    contain
                    :src="require('@/assets/images/svg/trending.svg')"
                  />

                  <div>
                    <v-card-title class="headline d-flex">
                      <span>Most Popular Tags</span>
                    </v-card-title>

                    <v-card-subtitle>
                      2 billion items available here through a library
                    </v-card-subtitle>
                  </div>
                </div>

                <v-divider />

                <v-sheet
                  height="500px"
                  class="overflow-auto pa-5 d-flex"
                  style="flex-wrap: wrap;"
                >
                  <a
                    v-for="(item, key) in randomizedTagAttrs"
                    :key="key"
                    style="flex: 1 1 auto"
                    class="mr-5 text-decoration-underline text--secondary subtitle"
                    :class="item.class"
                    @click="handleClickItemSearch('tag', item.tag)"
                    v-text="item.tag"
                  ></a>
                </v-sheet>
              </v-container>
            </v-card>
          </v-col>

          <!-- Recently Added -->
          <v-col
            cols="12"
            sm="12"
            md="12"
          >
            <v-card
              class="mx-auto"
              outlined
            >
              <v-container>
                <div class="d-flex">
                  <v-img
                    class="ml-3"
                    max-width="50"
                    contain
                    :src="require('@/assets/images/svg/new.svg')"
                  />

                  <div>
                    <v-card-title class="headline d-flex">
                      <span>Recently Added</span>
                    </v-card-title>

                    <v-card-subtitle>
                      2 billion items available here through a library
                    </v-card-subtitle>
                  </div>
                </div>

                <v-divider />

                <v-sheet
                  height="500px"
                  class="overflow-auto"
                >
                  <v-card-subtitle
                    v-for="(item, key) in recentArchivesList"
                    :key="key"
                  >
                    <p
                      class="headline font-weight-bold"
                      style="cursor: pointer"
                      @click="$router.push({ name: 'PublicArchiveDetail', params: { id: item.archives.id } })"
                    >
                      {{ item.archives.title | $truncateString(20) }}
                    </p>

                    <v-chip
                      v-for="(currItem, itemKey) in item.tags"
                      :key="itemKey"
                      class="ma-1 blue lighten-5"
                      label
                      x-small
                      v-text="currItem"
                    />

                    <v-divider
                      v-if="(key + 1) < recentArchivesList.length"
                      class="mt-5"
                    />
                  </v-card-subtitle>
                </v-sheet>
              </v-container>
            </v-card>
          </v-col>
        </v-row>
      </v-sheet>
    </v-container>
  </div>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState } from 'vuex'

import _sample from 'lodash/sample'

export default {
  name: 'Home',

  data () {
    return {
      searchParams: {
        filterBy: ['all'],
        q: ['']
      },

      dataStatus: {
        home: {
          loading: true
        }
      }
    }
  },

  computed: {
    ...mapState('tags', {
      popularTagsList: 'popularTagsList'
    }),

    ...mapState('archives', {
      recentArchivesList: 'recentArchivesList'
    }),

    ...mapState('subjects', {
      homeSubjects: 'homeSubjects'
    }),

    randomizedTagAttrs () {
      const list = this.popularTagsList
      const formatted = []
      const classList = ['display-1', 'headline', 'subtitle', 'title']

      for (let i = 0; i < list.length; i++) {
        const curr = list[i]
        formatted.push({
          class: _sample(classList, 1),
          tag: curr.tag,
          tag_id: curr.tag_id
        })
      }

      return formatted
    }
  },

  watch: {
    $route: {
      async handler (data) {
        await this.bootstrap({ ...data.query })
      },

      immediate: true
    }
  },

  methods: {
    ...mapActions('tags', {
      getPopularTagsList: 'getPopularTagsList'
    }),

    ...mapActions('archives', {
      getRecentList: 'getRecentList'
    }),

    handleClickItemSearch (filterBy, q) {
      return this.$router.push({
        name: 'public-archives',
        query: { filterBy, q }
      })
    },

    trigger () {
      this.$router.push({
        name: 'public-archives',
        query: this.searchParams
      })
    },

    bootstrap () {
      const config = {
        loading: 'dataStatus.home.loading'
      }

      this.statusWrapper(async () => {
        await Promise.all([
          this.getPopularTagsList({ ...this.$route.query }),
          this.getRecentList({ ...this.$route.query })
        ])
      }, config)
    }
  }
}
</script>
